JUnit:可以“期望”包装异常吗?

java exception junit 匿名 | 2020-02-27 02:21:00


我知道可以在JUnit中定义一个“预期”异常,这样做:
@Test(expect=MyException.class)
public void someMethod() { ... }

但是如果总是有相同的异常被抛出,但是有不同的“嵌套”原因,
有什么建议吗?





7 答案



从JUnit 4.11开始,您可以使用
ExpectedException
规则的
expectCause()
方法:
import static org.hamcrest.CoreMatchers.*;
// ...
@Rule
public ExpectedException expectedException = ExpectedException.none();
@Test
public void throwsNestedException() throws Exception {
expectedException.expectCause(isA(SomeNestedException.class));
throw new ParentException("foo", new SomeNestedException("bar"));
}
br

2020-02-27 02:21:24
匿名


您可以将测试代码包装在try/catch块中,捕获抛出的异常,检查内部原因,记录/断言/任何内容,然后重新抛出异常(如果需要)。

2020-02-27 02:21:11
匿名


如果使用的是最新版本的JUnit,则可以扩展默认的测试运行程序来处理此问题(不必将每个方法包装在try/catch块中)
ExtendedTest runner.java-新的测试运行程序:
public class ExtendedTestRunner extends BlockJUnit4ClassRunner
{
public ExtendedTestRunner( Class> clazz )
throws InitializationError
{
super( clazz );
}
@Override
protected Statement possiblyExpectingExceptions( FrameworkMethod method,
Object test,
Statement next )
{
ExtendedTest annotation = method.getAnnotation( ExtendedTest.class );
return expectsCauseException( annotation ) ?
new ExpectCauseException( next, getExpectedCauseException( annotation ) ) :
super.possiblyExpectingExceptions( method, test, next );
}
@Override
protected List computeTestMethods()
{
Set testMethods = new HashSet( super.computeTestMethods() );
testMethods.addAll( getTestClass().getAnnotatedMethods( ExtendedTest.class ) );
return testMethods;
}
@Override
protected void validateTestMethods( List errors )
{
super.validateTestMethods( errors );
validatePublicVoidNoArgMethods( ExtendedTest.class, false, errors );
}
private Class extends Throwable> getExpectedCauseException( ExtendedTest annotation )
{
if (annotation == null || annotation.expectedCause() == ExtendedTest.None.class)
return null;
else
return annotation.expectedCause();
}
private boolean expectsCauseException( ExtendedTest annotation) {
return getExpectedCauseException(annotation) != null;
}
}

ExtendedTest.java-标记测试方法的注释使用:
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
public @interface ExtendedTest
{
/**
* Default empty exception
*/
static class None extends Throwable {
private static final long serialVersionUID= 1L;
private None() {
}
}
Class extends Throwable> expectedCause() default None.class;
}

ExpectCauseException.java-新的JUnit语句:
public class ExpectCauseException extends Statement
{
private Statement fNext;
private final Class extends Throwable> fExpected;
public ExpectCauseException( Statement next, Class extends Throwable> expected )
{
fNext= next;
fExpected= expected;
}
@Override
public void evaluate() throws Exception
{
boolean complete = false;
try {
fNext.evaluate();
complete = true;
} catch (Throwable e) {
if ( e.getCause() == null || !fExpected.isAssignableFrom( e.getCause().getClass() ) )
{
String message = "Unexpected exception cause, expected + fExpected.getName() + "> but was + ( e.getCause() == null ? "none" : e.getCause().getClass().getName() ) + ">";
throw new Exception(message, e);
}
}
if (complete)
throw new AssertionError( "Expected exception cause: "
+ fExpected.getName());
}
}

用法:
@RunWith( ExtendedTestRunner.class )
public class MyTests
{
@ExtendedTest( expectedCause = MyException.class )
public void someMethod()
{
throw new RuntimeException( new MyException() );
}
}

2020-02-27 02:21:36
匿名

您始终可以手动操作:

@Test
public void someMethod() {
try{
... all your code
} catch (Exception e){
// check your nested clauses
if(e.getCause() instanceof FooException){
// pass
} else {
Assert.fail("unexpected exception");
}
}

2020-02-27 02:21:53
匿名


您可以为异常创建匹配器。即使您使用的是另一个测试运行程序,如Arquillian的
@RunWith(Arquillian.class)
,这样您就不能使用上面建议的
@RunWith(ExtendedTestRunner.class)
方法了。
这里有一个简单的示例:
public class ExceptionMatcher extends BaseMatcher {
private Class extends Throwable>[] classes;
// @SafeVarargs // public ExceptionMatcher(Class extends Throwable>... classes) {
this.classes = classes;
}
@Override
public boolean matches(Object item) {
for (Class extends Throwable> klass : classes) {
if (! klass.isInstance(item)) {
return false;
}
item = ((Throwable) item).getCause();
}
return true;
}
@Override
public void describeTo(Description descr) {
descr.appendText("unexpected exception");
}
}

然后将它与@Rule一起使用,并期望这样的异常:
@Rule
public ExpectedException thrown = ExpectedException.none();
@Test
public void testSomething() {
thrown.expect(new ExceptionMatcher(IllegalArgumentException.class, IllegalStateException.class));
throw new IllegalArgumentException("foo", new IllegalStateException("bar"));
}

由Craig Ringer添加2012年编辑:一个增强和更可靠的版本:
基本用法从上面没有改变
可以传递可选的第一个参数
boolean rethrow
来引发不匹配的异常。这将保留嵌套异常的堆栈跟踪,以便于调试。
使用Apache Commons Lang ExceptionUtils来处理原因循环,并处理某些常见异常类使用的非标准异常嵌套。
Self-descripe包括可接受的异常
Self-descripe on failure包括异常的原因堆栈遇到
Handle Java 7警告。删除旧版本上的
@SaveVarargs

完整代码:
import org.apache.commons.lang3.exception.ExceptionUtils;
import org.hamcrest.BaseMatcher;
import org.hamcrest.Description;

public class ExceptionMatcher extends BaseMatcher {
private Class extends Throwable>[] acceptedClasses;
private Throwable[] nestedExceptions;
private final boolean rethrow;
@SafeVarargs
public ExceptionMatcher(Class extends Throwable>... classes) {
this(false, classes);
}
@SafeVarargs
public ExceptionMatcher(boolean rethrow, Class extends Throwable>... classes) {
this.rethrow = rethrow;
this.acceptedClasses = classes;
}
@Override
public boolean matches(Object item) {
nestedExceptions = ExceptionUtils.getThrowables((Throwable)item);
for (Class extends Throwable> acceptedClass : acceptedClasses) {
for (Throwable nestedException : nestedExceptions) {
if (acceptedClass.isInstance(nestedException)) {
return true;
}
}
}
if (rethrow) {
throw new AssertionError(buildDescription(), (Throwable)item);
}
return false;
}
private String buildDescription() {
StringBuilder sb = new StringBuilder();
sb.append("Unexpected exception. Acceptable (possibly nested) exceptions are:");
for (Class extends Throwable> klass : acceptedClasses) {
sb.append("\n ");
sb.append(klass.toString());
}
if (nestedExceptions != null) {
sb.append("\nNested exceptions found were:");
for (Throwable nestedException : nestedExceptions) {
sb.append("\n ");
sb.append(nestedException.getClass().toString());
}
}
return sb.toString();
}
@Override
public void describeTo(Description description) {
description.appendText(buildDescription());
}
}

典型输出:
java.lang.AssertionError:  Expected: Unexpected exception. Acceptable (possibly nested) exceptions are:
class some.application.Exception
Nested exceptions found were:
class javax.ejb.EJBTransactionRolledbackException
class javax.persistence.NoResultException
got:

2020-02-27 02:22:14
匿名


为此我写了一个小JUnit扩展。静态帮助函数接受一个函数体和一组预期的异常:
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;
import java.util.Arrays;
public class AssertExt {
public static interface Runnable {
void run() throws Exception;
}
public static void assertExpectedExceptionCause( Runnable runnable, @SuppressWarnings("unchecked") Class[] expectedExceptions ) {
boolean thrown = false;
try {
runnable.run();
} catch( Throwable throwable ) {
final Throwable cause = throwable.getCause();
if( null != cause ) {
assertTrue( Arrays.asList( expectedExceptions ).contains( cause.getClass() ) );
thrown = true;
}
}
if( !thrown ) {
fail( "Expected exception not thrown or thrown exception had no cause!" );
}
}
}

现在可以检查预期的嵌套异常,如so:
import static AssertExt.assertExpectedExceptionCause;
import org.junit.Test;
public class TestExample {
@Test
public void testExpectedExceptionCauses() {
assertExpectedExceptionCause( new AssertExt.Runnable(){
public void run() throws Exception {
throw new Exception( new NullPointerException() );
}
}, new Class[]{ NullPointerException.class } );
}
}

这样可以省去您一次又一次地编写相同的锅炉板代码。

2020-02-27 02:22:32
匿名


最简洁的语法由catch异常提供:
import static com.googlecode.catchexception.CatchException.*;
catchException(myObj).doSomethingNasty();
assertTrue(caughtException().getCause() instanceof MyException);

2020-02-27 02:23:01
匿名


World is powered by solitude
备案号:湘ICP备19012068号